import logging
import robustapply

class ExtensionPoint(object):
    def __init__(self, use_one=False, plugins=[]):
        self.plugins = plugins
        self.use_one = use_one

    def activate(self, *args, **kwargs):
        if self.use_one:
            func = self.plugins[0]
            return {func : robustapply.robustApply(func, *args, **kwargs)}
        else:
            return_values = {}
            for func in self.plugins:
                return_values[func] = robustapply.robustApply(func, *args, **kwargs)
            return return_values

class Plugin(object):
     pass
